#include<bits/stdc++.h>
using namespace std;

const int maxn=5e5+5;

struct Edge
{
    int tot;
    int head[maxn];
    struct edgenode{int to,nxt;}edge[maxn*2];
    inline void add(int x,int y)
    {
        tot++;
        edge[tot].to=y;
        edge[tot].nxt=head[x];
        head[x]=tot;
    }
}T;

int n,m,cok;
int st[maxn][21],dep[maxn],dfn[maxn],fst[maxn][21];

inline void dfs(int u,int f)
{
    dfn[u]=++cok;
    st[cok][0]=f;dep[u]=dep[f]+1;
    for(int i=T.head[u];i;i=T.edge[i].nxt)
    {
        int v=T.edge[i].to;
        if(v==f) continue;
        dfs(v,u);
    }
}
inline int Min1(int x,int y){return dep[x]<dep[y]?x:y;}
inline int Max1(int x,int y){return dep[x]>dep[y]?x:y;}
inline void init1()
{
    for(int len=1;len<=log2(n);len++) for(int j=1;j<=n-(1<<len)+1;j++)
        st[j][len]=Min1(st[j][len-1],st[j+(1<<(len-1))][len-1]);
}
inline int Lca(int x,int y)
{
    if(x==y) return x;
    x=dfn[x],y=dfn[y];
    if(x>y) swap(x,y);
    x++;int k=log2(y-x+1);
    return Min1(st[x][k],st[y-(1<<k)+1][k]);
}
inline void init2()
{
    for(int i=1;i<=n;i++) fst[i][0]=i;
    for(int len=1;len<=log2(n);len++) for(int j=1;j<=n-(1<<len)+1;j++)
        fst[j][len]=Lca(fst[j][len-1],fst[j+(1<<(len-1))][len-1]);
}
inline int qry(int l,int r)
{
    int k=log2(r-l+1);
    return Lca(fst[l][k],fst[r-(1<<k)+1][k]);
}

int main()
{
    // freopen("query1.in","r",stdin);
    freopen("query.in","r",stdin);
    freopen("query.out","w",stdout);
    scanf("%d",&n);
    for(int i=1;i<n;i++)
    {
        int u,v;
        scanf("%d%d",&u,&v);
        T.add(u,v),T.add(v,u);
    }
    dfs(1,0);
    init1();
    init2();
    scanf("%d",&m);
    for(int i=1;i<=m;i++)
    {
        int l,r,k;
        scanf("%d%d%d",&l,&r,&k);
        int ans=0;
        for(int j=l;j<=r-k+1;j++)
        {
            int jr=j+k-1;
            ans=max(ans,dep[qry(j,jr)]);
        }
        printf("%d\n",ans);
    }
}